#1462 error in clock scan for "month"/"year"

obsolete: 8.3.2
closed-fixed
5
2001-10-18
2001-04-03
No

Hello,

We seem to have stumble across a possible bug in "clock
scan" command
which occurs with tcl8.0.5 as well as tcl8.3.2
versions. The following
two lines of code returns different results, when
basevalue is set to
any value between midnight to 7:00am and the script is
run under Pacific
time-zone:

scan year -base $basevalue -gmt 0
scan year -base $basevalue -gmt 1

Here's a sample output for various runs, the script is
attached as a file:

Tcl_version=8.3.2
base_seconds=985183078, current_time=Wed Mar 21
05:57:58 Pacific
Standard Time 2001
----------+--------------------------+-------------------------------
Relative | Local Time | GMT
Time
----------+--------------------------+-------------------------------
today | Wed Mar 21 05:57:58 2001 | Wed Mar 21
05:57:58 2001
tomorrow | Thu Mar 22 05:57:58 2001 | Thu Mar 22
05:57:58 2001
week | Wed Mar 28 05:57:58 2001 | Wed Mar 28
05:57:58 2001
4 weeks | Wed Apr 18 05:57:58 2001 | Wed Apr 18
05:57:58 2001
month | Sat Apr 21 05:57:58 2001 | Fri Apr 20
05:57:58 2001 *
5 weeks | Wed Apr 25 05:57:58 2001 | Wed Apr 25
05:57:58 2001
6 months | Fri Sep 21 05:57:58 2001 | Thu Sep 20
05:57:58 2001 *
26 weeks | Wed Sep 19 05:57:58 2001 | Wed Sep 19
05:57:58 2001
12 months | Thu Mar 21 05:57:58 2002 | Wed Mar 20
05:57:58 2002 *
52 weeks | Wed Mar 20 05:57:58 2002 | Wed Mar 20
05:57:58 2002
365 days | Thu Mar 21 05:57:58 2002 | Thu Mar 21
05:57:58 2002
year | Thu Mar 21 05:57:58 2002 | Wed Mar 20
05:57:58 2002 *
----------+--------------------------+-------------------------------
* Dates for local time and gmt time are skewed by one
day

It is interesting to note that the dates are same when
relative time
is specified as "365 days", but different when
specified as a "year"
The problem seems to occur for "year" and "month"
specifications, but
not with "day" or "week" specifications.

Any idea where the problem could be and what would be
the fix for it? Or
have I misunderstood something?

Thanks,
Hemang.

Discussion

  • Hemang Lavana

    Hemang Lavana - 2001-04-03

    clock.tcl - script to reproduce the error

     
    Attachments
  • Donal K. Fellows

    • labels: --> 104236
    • summary: error in clock scan for "month"/"year" --> error in clock scan for "month"/"year"
    • milestone: --> obsolete: 8.3.2
     
  • Don Porter

    Don Porter - 2001-04-04
    • summary: error in clock scan for "month"/"year" --> error in clock scan for "month"/"year"
    • labels: 104236 --> 06. Time Measurement
     
  • Hemang Lavana

    Hemang Lavana - 2001-04-05

    Logged In: YES
    user_id=81875

    Please see patch #414024 for the fix.

     
  • Andreas Kupries

    Andreas Kupries - 2001-07-31
    • summary: error in clock scan for "month"/"year" --> error in clock scan for "month"/"year"
    • assigned_to: nobody --> kennykb
     
  • Jeffrey Hobbs

    Jeffrey Hobbs - 2001-10-18
    • assigned_to: kennykb --> hobbs
    • summary: error in clock scan for "month"/"year" --> error in clock scan for "month"/"year"
     
  • Jeffrey Hobbs

    Jeffrey Hobbs - 2001-10-18
    • summary: error in clock scan for "month"/"year" --> error in clock scan for "month"/"year"
    • status: open --> closed-fixed
     
  • Jeffrey Hobbs

    Jeffrey Hobbs - 2001-10-18

    Logged In: YES
    user_id=72656

    Added to 8.3.4 and 8.4a4cvs.

     

Get latest updates about Open Source Projects, Conferences and News.

Sign up for the SourceForge newsletter:





No, thanks